/*!
* js-data-schema
* @version 1.2.5 - Homepage <https://github.com/js-data/js-data-schema/>
* @author Jason Dobry <jason.dobry@gmail.com>
* @copyright (c) 2013-2014 Jason Dobry <https://github.io/js-data/js-data-schema>
* @license MIT <https://github.com/js-data/js-data-schema/blob/master/LICENSE>
*
* @overview Define and validate rules, datatypes and schemata in Node and in the browser.
*/

!function(a,b){"object"==typeof exports&&"object"==typeof module?module.exports=b():"function"==typeof define&&define.amd?define(b):"object"==typeof exports?exports.Schemator=b():a.Schemator=b()}(this,function(){return function(a){function b(d){if(c[d])return c[d].exports;var e=c[d]={exports:{},id:d,loaded:!1};return a[d].call(e.exports,e,e.exports,b),e.loaded=!0,e.exports}var c={};return b.m=a,b.c=c,b.p="",b(0)}([function(a,b,c){function d(a){return a&&a.__esModule?a:{"default":a}}function e(a,b){if(!(a instanceof b))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(b,"__esModule",{value:!0});var f=function(){function a(a,b){for(var c=0;c<b.length;c++){var d=b[c];d.enumerable=d.enumerable||!1,d.configurable=!0,"value"in d&&(d.writable=!0),Object.defineProperty(a,d.key,d)}}return function(b,c,d){return c&&a(b.prototype,c),d&&a(b,d),b}}(),g=c(1),h=d(g),i=c(47),j=d(i),k=c(48),l=d(k),m=c(49),n=d(m),o=1,p=function(){function a(){e(this,a),this.dataTypes={},this.rules={},this.schemata={},this.id=o++}return f(a,[{key:"availableDataTypes",value:function(){return h["default"].unique(h["default"].keys(this.dataTypes).concat(h["default"].keys(j["default"])))}},{key:"availableRules",value:function(){return h["default"].unique(h["default"].keys(this.rules).concat(h["default"].keys(l["default"])))}},{key:"availableSchemata",value:function(){return h["default"].keys(this.schemata)}},{key:"defineDataType",value:function(a,b){if(!h["default"].isString(a))throw new Error('"name" must be a string!');if(!h["default"].isFunction(b))throw new Error('"typeDefinition" must be a function!');if(this.dataTypes[a])throw new Error("dataType already registered!");this.dataTypes[a]=b}},{key:"defineRule",value:function(a,b,c){if(!h["default"].isString(a))throw new Error('"name" must be a string!');if(!h["default"].isFunction(b))throw new Error('"ruleFunc" must be a function!');if(this.rules[a])throw new Error("rule already registered!");this.rules[a]=b,this.rules[a].async=!!c}},{key:"defineSchema",value:function(a,b){if(this.schemata[a])throw new Error("schema already registered!");if(b instanceof n["default"])throw new Error("schema registered elsewhere!");return this.schemata[a]=new n["default"](a,b,this),this.schemata[a].parent=this,this.schemata[a]}},{key:"getDataType",value:function(a){return this.dataTypes[a]||j["default"][a]}},{key:"getRule",value:function(a){return this.rules[a]||l["default"][a]}},{key:"getSchema",value:function(a){return this.schemata[a]}},{key:"removeDataType",value:function(a){delete this.dataTypes[a]}},{key:"removeRule",value:function(a){delete this.rules[a]}},{key:"removeSchema",value:function(a){delete this.schemata[a]}},{key:"schemaCheck",value:function(a){if(!this.schemata[a])throw new Error("schema is not registered!")}},{key:"validateSync",value:function(a,b,c){return this.schemaCheck(a),this.schemata[a].validateSync(b,c)}},{key:"validate",value:function(a,b,c,d){return this.schemaCheck(a),this.schemata[a].validate(b,c,d)}},{key:"addDefaultsToTarget",value:function(a,b,c){return this.schemaCheck(a),this.schemata[a].addDefaultsToTarget(b,c)}},{key:"setDefaults",value:function(a,b){return this.schemaCheck(a),this.schemata[a].setDefaults(b)}},{key:"getDefaults",value:function(a){return this.schemaCheck(a),this.schemata[a].getDefaults()}},{key:"stripNonSchemaAttrs",value:function(a,b){return this.schemaCheck(a),this.schemata[a].stripNonSchemaAttrs(b)}}]),a}();b["default"]=p,a.exports=b["default"]},function(a,b,c){function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(b,"__esModule",{value:!0});var e=c(7),f=d(e),g=c(10),h=d(g),i=c(11),j=d(i),k=c(12),l=d(k),m=c(13),n=d(m),o=c(14),p=d(o),q=c(15),r=d(q),s=c(16),t=d(s),u=c(17),v=d(u),w=c(18),x=d(w),y=c(19),z=d(y),A=c(20),B=d(A),C=c(22),D=d(C),E=c(2),F=d(E),G=c(3),H=d(G),I=c(23),J=d(I),K=c(24),L=d(K),M=c(26),N=d(M),O=c(31),P=d(O),Q=c(32),R=d(Q),S=c(36),T=d(S),U=c(38),V=d(U),W=c(40),X=d(W),Y=c(44),Z=d(Y),$=c(41),_=d($),aa=c(46),ba=d(aa);b["default"]={isString:f["default"],isBoolean:h["default"],isNumber:j["default"],isObject:l["default"],isDate:n["default"],isFunction:p["default"],isUndefined:r["default"],isArray:t["default"],isEmpty:v["default"],toString:x["default"],toNumber:z["default"],get:B["default"],deepMixIn:D["default"],deepFillIn:F["default"],forOwn:H["default"],keys:J["default"],pick:L["default"],filter:N["default"],map:P["default"],merge:R["default"],unset:T["default"],contains:V["default"],intersection:X["default"],difference:Z["default"],unique:_["default"],toInt:ba["default"],errMsg:function(a,b,c){return{rule:a,actual:b,expected:c}},parallel:function(a,b){function c(a){e+=1,(a||e>=f)&&b(a,d)}var d={},e=0,f=0;H["default"](a,function(){f+=1}),H["default"](a,function(a,b){a(function(a){var e=Array.prototype.slice.call(arguments,1);e.length<=1&&(e=e[0]),d[b]=e,c(a)})})}},a.exports=b["default"]},function(a,b,c){function d(a,b){for(var c,g=0,h=arguments.length;++g<h;)c=arguments[g],c&&e(c,function(b,c){var e=a[c];null==e?a[c]=b:f(e)&&f(b)&&d(e,b)});return a}var e=c(3),f=c(6);a.exports=d},function(a,b,c){function d(a,b,c){f(a,function(d,f){return e(a,f)?b.call(c,a[f],f,a):void 0})}var e=c(4),f=c(5);a.exports=d},function(a,b,c){function d(a,b){return Object.prototype.hasOwnProperty.call(a,b)}a.exports=d},function(a,b,c){function d(){h=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],g=!0;for(var a in{toString:null})g=!1}function e(a,b,c){var e,j=0;null==g&&d();for(e in a)if(f(b,a,e,c)===!1)break;if(g)for(var k=a.constructor,l=!!k&&a===k.prototype;(e=h[j++])&&("constructor"===e&&(l||!i(a,e))||a[e]===Object.prototype[e]||f(b,a,e,c)!==!1););}function f(a,b,c,d){return a.call(d,b[c],c,b)}var g,h,i=c(4);a.exports=e},function(a,b,c){function d(a){return!!a&&"object"==typeof a&&a.constructor===Object}a.exports=d},function(a,b,c){function d(a){return e(a,"String")}var e=c(8);a.exports=d},function(a,b,c){function d(a,b){return e(a)===b}var e=c(9);a.exports=d},function(a,b,c){function d(a){return null===a?"Null":a===e?"Undefined":f.exec(g.call(a))[1]}var e,f=/^\[object (.*)\]$/,g=Object.prototype.toString;a.exports=d},function(a,b,c){function d(a){return e(a,"Boolean")}var e=c(8);a.exports=d},function(a,b,c){function d(a){return e(a,"Number")}var e=c(8);a.exports=d},function(a,b,c){function d(a){return e(a,"Object")}var e=c(8);a.exports=d},function(a,b,c){function d(a){return e(a,"Date")}var e=c(8);a.exports=d},function(a,b,c){function d(a){return e(a,"Function")}var e=c(8);a.exports=d},function(a,b,c){function d(a){return a===e}var e;a.exports=d},function(a,b,c){var d=c(8),e=Array.isArray||function(a){return d(a,"Array")};a.exports=e},function(a,b,c){function d(a){if(null==a)return!0;if("string"==typeof a||f(a))return!a.length;if("object"==typeof a){var b=!0;return e(a,function(){return b=!1,!1}),b}return!0}var e=c(3),f=c(16);a.exports=d},function(a,b,c){function d(a){return null==a?"":a.toString()}a.exports=d},function(a,b,c){function d(a){return"number"==typeof a?a:a?"string"==typeof a?parseFloat(a):e(a)?NaN:Number(a):0}var e=c(16);a.exports=d},function(a,b,c){function d(a,b){for(var c=b.split("."),d=c.pop();b=c.shift();)if(a=a[b],null==a)return;return a[d]}c(21);a.exports=d},function(a,b,c){function d(a){switch(typeof a){case"string":case"number":case"boolean":return!0}return null==a}a.exports=d},function(a,b,c){function d(a,b){for(var c,d=0,g=arguments.length;++d<g;)c=arguments[d],c&&f(c,e,a);return a}function e(a,b){var c=this[b];g(a)&&g(c)?d(c,a):this[b]=a}var f=c(3),g=c(6);a.exports=d},function(a,b,c){var d=c(3),e=Object.keys||function(a){var b=[];return d(a,function(a,c){b.push(c)}),b};a.exports=e},function(a,b,c){function d(a,b){for(var c,d="string"!=typeof arguments[1]?arguments[1]:e(arguments,1),f={},g=0;c=d[g++];)f[c]=a[c];return f}var e=c(25);a.exports=d},function(a,b,c){function d(a,b,c){var d=a.length;b=null==b?0:0>b?Math.max(d+b,0):Math.min(b,d),c=null==c?d:0>c?Math.max(d+c,0):Math.min(c,d);for(var e=[];c>b;)e.push(a[b++]);return e}a.exports=d},function(a,b,c){function d(a,b,c){b=f(b,c);var d={};return e(a,function(a,c,e){b(a,c,e)&&(d[c]=a)}),d}var e=c(3),f=c(27);a.exports=d},function(a,b,c){function d(a,b){if(null==a)return e;switch(typeof a){case"function":return"undefined"!=typeof b?function(c,d,e){return a.call(b,c,d,e)}:a;case"object":return function(b){return g(b,a)};case"string":case"number":return f(a)}}var e=c(28),f=c(29),g=c(30);a.exports=d},function(a,b,c){function d(a){return a}a.exports=d},function(a,b,c){function d(a){return function(b){return b[a]}}a.exports=d},function(a,b,c){function d(a,b){for(var c=-1,d=a.length;++c<d;)if(g(a[c],b))return!0;return!1}function e(a,b){for(var c=-1,e=b.length;++c<e;)if(!d(a,b[c]))return!1;return!0}function f(a,b){var c=!0;return h(b,function(b,d){return g(a[d],b)?void 0:c=!1}),c}function g(a,b){return a&&"object"==typeof a?i(a)&&i(b)?e(a,b):f(a,b):a===b}var h=c(3),i=c(16);a.exports=g},function(a,b,c){function d(a,b,c){b=f(b,c);var d={};return e(a,function(a,c,e){d[c]=b(a,c,e)}),d}var e=c(3),f=c(27);a.exports=d},function(a,b,c){function d(){var a,b,c,h,i=1;for(h=f(arguments[0]);c=arguments[i++];)for(a in c)e(c,a)&&(b=c[a],g(b)&&g(h[a])?h[a]=d(h[a],b):h[a]=f(b));return h}var e=c(4),f=c(33),g=c(12);a.exports=d},function(a,b,c){function d(a,b){switch(i(a)){case"Object":return e(a,b);case"Array":return f(a,b);default:return g(a)}}function e(a,b){if(j(a)){var c={};return h(a,function(a,c){this[c]=d(a,b)},c),c}return b?b(a):a}function f(a,b){for(var c=[],e=-1,f=a.length;++e<f;)c[e]=d(a[e],b);return c}var g=c(34),h=c(3),i=c(9),j=c(6);a.exports=d},function(a,b,c){function d(a){switch(i(a)){case"Object":return e(a);case"Array":return h(a);case"RegExp":return f(a);case"Date":return g(a);default:return a}}function e(a){return j(a)?k({},a):a}function f(a){var b="";return b+=a.multiline?"m":"",b+=a.global?"g":"",b+=a.ignoreCase?"i":"",new RegExp(a.source,b)}function g(a){return new Date(+a)}function h(a){return a.slice()}var i=c(9),j=c(6),k=c(35);a.exports=d},function(a,b,c){function d(a,b){for(var c,d=0,g=arguments.length;++d<g;)c=arguments[d],null!=c&&f(c,e,a);return a}function e(a,b){this[b]=a}var f=c(3);a.exports=d},function(a,b,c){function d(a,b){if(e(a,b)){for(var c=b.split("."),d=c.pop();b=c.shift();)a=a[b];return delete a[d]}return!0}var e=c(37);a.exports=d},function(a,b,c){function d(a,b){return f(a,b)!==e}var e,f=c(20);a.exports=d},function(a,b,c){function d(a,b){return-1!==e(a,b)}var e=c(39);a.exports=d},function(a,b,c){function d(a,b,c){if(c=c||0,null==a)return-1;for(var d=a.length,e=0>c?d+c:c;d>e;){if(a[e]===b)return e;e++}return-1}a.exports=d},function(a,b,c){function d(a){var b=i(arguments,1),c=f(e(a),function(a){return g(b,function(b){return h(b,a)})});return c}var e=c(41),f=c(42),g=c(43),h=c(38),i=c(25);a.exports=d},function(a,b,c){function d(a,b){return b=b||e,f(a,function(a,c,d){for(var e=d.length;++c<e;)if(b(a,d[c]))return!1;return!0})}function e(a,b){return a===b}var f=c(42);a.exports=d},function(a,b,c){function d(a,b,c){b=e(b,c);var d=[];if(null==a)return d;for(var f,g=-1,h=a.length;++g<h;)f=a[g],b(f,g,a)&&d.push(f);return d}var e=c(27);a.exports=d},function(a,b,c){function d(a,b,c){b=e(b,c);var d=!0;if(null==a)return d;for(var f=-1,g=a.length;++f<g;)if(!b(a[f],f,a)){d=!1;break}return d}var e=c(27);a.exports=d},function(a,b,c){function d(a){var b=i(arguments,1),c=f(e(a),function(a){return!g(b,function(b){return h(b,a)})});return c}var e=c(41),f=c(42),g=c(45),h=c(38),i=c(25);a.exports=d},function(a,b,c){function d(a,b,c){b=e(b,c);var d=!1;if(null==a)return d;for(var f=-1,g=a.length;++f<g;)if(b(a[f],f,a)){d=!0;break}return d}var e=c(27);a.exports=d},function(a,b,c){function d(a){return~~a}a.exports=d},function(a,b,c){function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(b,"__esModule",{value:!0});var e=c(1),f=d(e);b["default"]={string:function(a){return f["default"].isString(a)?null:f["default"].errMsg("type",typeof a,"string")},number:function(a){return f["default"].isNumber(a)?null:f["default"].errMsg("type",typeof a,"number")},integer:function(a){return f["default"].isNumber(a)?Math.abs(a)-Math.abs(f["default"].toInt(a))!==0?f["default"].errMsg("type","real","integer"):null:f["default"].errMsg("type",typeof a,"integer")},"float":function(a){return f["default"].isNumber(a)?null:f["default"].errMsg("type",typeof a,"float")},array:function(a){return f["default"].isArray(a)?null:f["default"].errMsg("type",typeof a,"array")},object:function(a){return f["default"].isObject(a)?null:f["default"].errMsg("type",typeof a,"object")},"boolean":function(a){return f["default"].isBoolean(a)?null:f["default"].errMsg("type",typeof a,"boolean")},date:function(a){return f["default"].isDate(a)?null:f["default"].errMsg("type",typeof a,"date")}},a.exports=b["default"]},function(a,b,c){function d(a){return a&&a.__esModule?a:{"default":a}}Object.defineProperty(b,"__esModule",{value:!0});var e=c(1),f=d(e),g=c(47),h=d(g);b["default"]={nullable:function(a,b){return null!==a&&void 0!==a||b?null:f["default"].errMsg("nullable","x === "+a,"x !== null && x !== undefined")},max:function(a,b){return f["default"].isNumber(a)&&f["default"].isNumber(b)&&a>b?f["default"].errMsg("max",""+a+" > "+b,""+a+" <= "+b):null},min:function(a,b){return f["default"].isNumber(a)&&f["default"].isNumber(b)&&b>a?f["default"].errMsg("min",""+a+" < "+b,""+a+" >= "+b):null},maxLength:function(a,b){return(f["default"].isString(a)||f["default"].isArray(a))&&f["default"].isNumber(b)&&a.length>b?f["default"].errMsg("maxLength",""+a.length+" > "+b,""+a.length+" <= "+b):null},minLength:function(a,b){return(f["default"].isString(a)||f["default"].isArray(a))&&f["default"].isNumber(b)&&a.length<b?f["default"].errMsg("minLength",""+a.length+" < "+b,""+a.length+" >= "+b):null},type:function(a,b,c,d){return c?c(a):d.dataTypes[b]?d.dataTypes[b](a):h["default"][b]?h["default"][b](a):null}},a.exports=b["default"]},function(a,b,c){function d(a){return a&&a.__esModule?a:{"default":a}}function e(a,b){if(!(a instanceof b))throw new TypeError("Cannot call a class as a function")}function f(a,b,c,d,e){var f=this,h=a+(a.length?".":"")+e,i=n["default"].get(this.schema,h);if(i)if(n["default"].isObject(d)||q(i)){var j=g.apply(this,[h,d||{},b]);j&&(c[e]=j)}else{if(!n["default"].isObject(i))return;if(i.nullable===!0){var k=this.parent.rules.nullable||p["default"].nullable,l=k.call(b.ctx,d,!0,void 0,this.parent);if(null===l)return}n["default"].forOwn(i,function(a,g){var h=f.parent.rules[g]||p["default"][g];if(h&&!h.async){var i=h.call(b.ctx,d,a,void 0,f.parent);i&&(c[e]||(c[e]={errors:[]}),c[e].errors.push(i))}})}}function g(a,b,c){var d=this,e={};try{if(n["default"].forOwn(b,function(b,g){f.call(d,a,c,e,b,g)}),!c.ignoreMissing){var g=a?n["default"].get(this.schema,a)||{}:this.schema,h=n["default"].difference(n["default"].keys(g),n["default"].keys(b));h=n["default"].pick(this.schema,h),h=n["default"].map(h,function(){return void 0}),n["default"].forOwn(h,function(b,g){f.call(d,a,c,e,b,g)})}return n["default"].isEmpty(e)?null:e}catch(i){return i}}function h(a,b,c,d,e,f,g){var h=this,j=d+c,k=n["default"].get(this.schema,j);if(k)if(n["default"].isObject(b)||q(k))f[c]=function(b,c){return function(d){i.apply(h,[b,c||{},a,d])}}(j,b);else{if(!n["default"].isObject(k))return;if(k.nullable===!0){var l=this.parent.rules.nullable||p["default"].nullable,m=l.call(a.ctx,b,!0,void 0,this.parent);if(null===m)return}n["default"].forOwn(k,function(d,f){var i=h.parent.rules[f]||p["default"][f];if(i&&i.async)g[""+f+"_"+d]=function(b,c,d,e){return function(f){b.call(a.ctx,d,e,function(a){f(null,{err:a,key:c})})}}(i,c,b,d);else{var j=i.call(a.ctx,b,d,void 0,h.parent);j&&(e[c]||(e[c]={errors:[]}),e[c].errors.push(j))}})}}function i(a,b,c,d){var e=this,f={},g=a+(a.length?".":""),i={},j={},k=c.first;if(delete c.first,n["default"].forOwn(b,function(a,b){h.call(e,c,a,b,g,f,i,j)}),!c.ignoreMissing){var l=a?n["default"].get(this.schema,a)||{}:this.schema,m=n["default"].difference(n["default"].keys(l),n["default"].keys(b));m=n["default"].pick(this.schema,m),m=n["default"].map(m,function(){return void 0}),n["default"].forOwn(m,function(a,b){h.call(e,c,a,b,g,f,i,j)})}var o={};n["default"].isEmpty(i)||(o.deepQueue=function(a){n["default"].parallel(i,a)}),n["default"].isEmpty(j)||(o.ruleQueue=function(a){n["default"].parallel(j,a)}),n["default"].isEmpty(o)?n["default"].isEmpty(f)?d(null):k?d(f):d(null,f):n["default"].parallel(o,function(a,b){b.deepQueue&&(b.deepQueue=n["default"].filter(b.deepQueue,function(a){return void 0!==a&&null!==a}),n["default"].deepMixIn(f,b.deepQueue)),b.ruleQueue&&(b.ruleQueue&&(b.ruleQueue=n["default"].filter(b.ruleQueue,function(a){return void 0!==a.err&&null!==a.err})),n["default"].forOwn(b.ruleQueue,function(a){f[a.key]||(f[a.key]={errors:[]}),f[a.key].errors.push(a.err)})),n["default"].isEmpty(f)?d(null):k?d(f):d(null,f)})}function j(a,b){b=b||[];var c=n["default"].keys(a),d=0===n["default"].intersection(c,b).length;n["default"].forOwn(a,function(c,e){d&&n["default"].isString(c)?a[e]={type:c}:n["default"].isObject(c)&&j(c,b)})}function k(a,b){n["default"].forOwn(a,function(c,d){b[d]?n["default"].isObject(c)&&n["default"].isObject(b[d])&&k(c,b[d]):n["default"].unset(a,d)})}Object.defineProperty(b,"__esModule",{value:!0});var l=function(){function a(a,b){for(var c=0;c<b.length;c++){var d=b[c];d.enumerable=d.enumerable||!1,d.configurable=!0,"value"in d&&(d.writable=!0),Object.defineProperty(a,d.key,d)}}return function(b,c,d){return c&&a(b.prototype,c),d&&a(b,d),b}}(),m=c(1),n=d(m),o=c(48),p=d(o),q=function(a){var b=!1;return n["default"].forOwn(a,function(a){return n["default"].isObject(a)?(b=!0,!1):void 0}),b},r={a:"Schema#validateSync(attrs[, options]): ",b:"Schema#validate(attrs[, options], cb): "},s=function(){function a(b,c,d){if(e(this,a),!n["default"].isString(b))throw new Error('"name" must be a string!');if(!n["default"].isObject(c))throw new Error('"schema" must be an object!');this.name=b,j(c,d?d.availableRules():p["default"]),this.schema=c}return l(a,[{key:"validateSync",value:function(a,b){if(b=b?b===!0?{ignoreMissing:!0}:b:{},!n["default"].isObject(a))throw new Error(""+r.a+"attrs: Must be an object!");if(!n["default"].isObject(b))throw new Error(""+r.a+"options: Must be an object!");return b.ctx=a,g.call(this,"",a,b)}},{key:"validate",value:function(a,b,c){if(b=b?b===!0?{ignoreMissing:!0}:b:{},n["default"].isFunction(b)&&(c=b,b={}),!n["default"].isFunction(c))throw new Error(""+r.b+"cb: Must be a function!");return n["default"].isObject(a)?n["default"].isObject(b)?(b.first=!0,b.ctx=a,void i.call(this,"",a,b,c)):c(new Error(""+r.b+"options: Must be an object!")):c(new Error(""+r.b+"attrs: Must be an object!"))}},{key:"addDefaultsToTarget",value:function(a,b){if(!n["default"].isObject(a))throw new Error('"target" must be an object!');if(!this.defaults)throw new Error("No defaults have been set!");b?n["default"].deepMixIn(a,this.defaults):n["default"].deepFillIn(a,this.defaults)}},{key:"setDefaults",value:function(a){if(!n["default"].isObject(a))throw new Error("Schema#defaults(attrs): attrs: Must be an object!");return this.defaults=n["default"].merge({},a),this}},{key:"getDefaults",value:function(){return n["default"].merge({},this.defaults)}},{key:"stripNonSchemaAttrs",value:function(a){return k(a,this.schema),a}}]),a}();b["default"]=s,a.exports=b["default"]}])});
//# sourceMappingURL=js-data-schema.min.map